#ifndef KMEANS_H
#define KMEANS_H
# include <dataset.h>

/**
 * @brief The kmeans class, ylopoihsh tis methodou kmeans
 */
class kmeans
{
private:
    /**
      dataset: To dataset me ta dedomena
      center : to kentro kathe omadas
      member : gia kathe protypo se poia omada einai
      team   : to plithos omadon
    */
    Dataset *dataset;
    Matrix center;
    vector<int>  member;
    int team;
    vector<int> teamMembers;


    /** Arxikopoihsh kentron**/
    void initCenters();
    /**
     * @brief nearestTeam, eyresi kontinoteris omadas
     * @param x
     * @return
     */
    int  nearestTeam(Data &x);
    /**
     * @brief updateCenters, enimerosi kentron
     */
    void updateCenters();
    /**
     * @brief distance, apostasi metaxy dyo dianusmaton x,y
     * @param x
     * @param y
     * @return
     */
    double distance(Data &x,Data &y);
public:
    /**
     * @brief kmeans, synartisi dimiurgias
     * @param d
     * @param nteams, plithos omadon
     */
    kmeans(Dataset *d,int nteams);
    /**
     * @brief runAlgorithm, o basikos algorithmos kmeans
     */
    void    runAlgorithm();

    /**
     * @brief getCenters, epistrofi pinaka kentron
     * @return
     */
    vector<Data> getCenters();
    /**
     * @brief getVariances, epistrofi diakymanseon
     * @return
     */
    Data          getVariances();
};

#endif // KMEANS_H
