#ifndef RBF_H
#define RBF_H
# include <dataset.h>
# include <kmeans.h>
class Rbf
{
private:
    Data weight;
    Matrix centroid;
    Data variance;

    Dataset *trainSet,*testSet;
    int   nweights;//centroids
    int   pattern_dimension;
     Data    classVector;
     /**
     * @brief init_arrays, arxikopoihsh ton pinakon tou RBF
     */
    void    init_arrays();
    /**
     * @brief gauss_function, epistrefei tin synartisi gauss
     * @param pattern
     * @param center
     * @param sigma
     * @return
     */
    double  gauss_function(Data &pattern,Data &center,double sigma);
    /**
     * @brief matrix_transpose, anastrofos pinaka
     * @param x
     * @return
     */
    Matrix  matrix_transpose(Matrix &x);
    /**
     * @brief matrix_mult, pollaplasiasmos pinakon
     * @param x
     * @param y
     * @return
     */
    Matrix  matrix_mult(Matrix &x,Matrix &y);
    /**
     * @brief matrix_inverse, ypologismos antistrofou pinaka
     * @param x
     * @return
     */
    Matrix  matrix_inverse(Matrix x);
    /**
     * @brief matrix_pseudoinverse, pseudo - antistrofos pinaka
     * @param x
     * @return
     */
    Matrix  matrix_pseudoinverse(Matrix &x);
public:
    /**
     * @brief Rbf, synartisi dimioyrgias
     */
    Rbf();
    /**
     * @brief setNumberOfWeights, kathorismos arithmou varon
     * @param K
     */
    void    setNumberOfWeights(int K);
    /**
     * @brief getNumberOfWeights, epistrofi arithmou varon
     * @return
     */
    int     getNumberOfWeights();
    /**
     * @brief setTrainSet, kathorismos synolou ekpaideysis
     * @param t
     */
    void    setTrainSet(Dataset *t);
    /**
     * @brief setTestSet, kathorismos synolou elegxou
     * @param t
     */
    void    setTestSet(Dataset *t);
    /**
     * @brief train. Ekpaideysi rbf
     */
    void    train();
    /**
     * @brief getOutput, epistrofi timis protypou
     * @param pattern
     * @return
     */
    double  getOutput(Data &pattern);
    /**
     * @brief getClass, epistrofi katigorias protypou
     * @param pattern
     * @return
     */
    double  getClass(Data &pattern);
    /**
     * @brief getTrainError, epistrofi sfalmatos ekpaideysis
     * @return
     */
    double  getTrainError();
    /**
     * @brief getTestError, epistrofi sfalmatos elegxou
     * @return
     */
    double  getTestError();
    /**
     * @brief getClassError, epistrofi sfalmatos elegxou katigorion
     * @return
     */
    double  getClassError();
    /**
     * @brief product, ginomeno pinakon
     * @param x
     * @param y
     * @return
     */
    double  product(Data &x,Data &y);
};

#endif // RBF_H
